/**
 *	Tutorial code by Matthieu Savary
 *	as featured on http://smallab.org/download/40/
 *	
 *	Made for http://craslab.org
 *	Distributed freely, for free, and with love
 *	Under the BSD License
 *	
 *	For Processing 2.0.1 and (hopefully) later
 *	
 */

// global variables
PFont myFont1, myFont2;
String mySentence = "";
float myFontSize = 64;

// setting up the sketch
void setup() {
  size(1024, 576);
  background(0);
  noStroke();
  smooth();

  // font and text related directives
  myFont1 = createFont("Georgia", 128);
  myFont2 = createFont("Helvetica", 128);
  textFont(myFont1);
  textAlign(CENTER, CENTER);
}

// the loop through time
void draw() {
  // the famous semi-transparent, overlaying rect trick
  fill(0, 15);
  rect(0, 0, width, height);

  // to avoid top & left side uncoolness
  translate(-50, -50);

  // draw motif using our global
  drawTextPattern(40, 30);
}

// keyboard events
void keyPressed() {
  // backspace
  if (keyCode == 8) {
    mySentence = "";

  // shift, alt, ctrl, cmd
  } else if (keyCode == 16 || keyCode == 17 || keyCode == 18 || keyCode == 157) {  
    // don't do no nothing

  // UP and DOWN arrows are used to change the font size
  } else if (keyCode == UP) {  
    myFontSize ++;
  } else if (keyCode == DOWN) {  
    myFontSize --;

  // LEFT and RIGHT to change the font itself
  } else if (keyCode == LEFT) {
    textFont(myFont1);
  } else if (keyCode == RIGHT) {
    textFont(myFont2);

  // default behavior: adding the last key to our sentence
  } else {
    mySentence += key;
  }
}

// mouse click events
void mousePressed() {
  // saving to a file with specific name corresponding to sentence
  saveFrame("print-"+mySentence+"-####.png");
  // clearing sketch
  background(0);
}

